package aplprolog.datastructures;

public class PrimIntArrayList {
	public int[] intdata;
	public int[][] arraydata;
	public int pointer = 0; 
	static final boolean INT=true, INTAR=false;
	boolean isInt = false;

	public PrimIntArrayList(int initialSize,boolean type){
		this.isInt = type;
		start(initialSize);
	}
	public PrimIntArrayList(boolean type){
		this.isInt = type;
		start(16);
	}
	
	public void start(int initialSize){
		if(isInt) intdata = new int[initialSize];
		else arraydata= new int[initialSize][];
	}
	
	public int getInt(int index){
		return intdata[index];
	}	
	public int[] getAr(int index){
		return arraydata[index];
	}

	public void addInt(int element){
		intdata[pointer] = element;
		pointer++;
		if(pointer==intdata.length)resize();
	}
	public void addAr(int[] element){
		arraydata[pointer] = element;
		pointer++;
		if(pointer==arraydata.length)resize();
	}

	public void addInt(int index, int element){
		for(int i = pointer; i > index; i--)
			intdata[i] = intdata[i-1];
		intdata[index] = element; 
		pointer++; 
		if(pointer==intdata.length)resize();
	}
	public void addAr(int index, int[] element){
		for(int i = pointer; i > index; i--)
			arraydata[i] = arraydata[i-1];
		arraydata[index] = element; 
		pointer++; 
		if(pointer==arraydata.length)resize();
	}
	
	public void resize(){
		if(isInt){
			int[] newdata = new int[intdata.length*2];
			for(int i = 0; i < pointer; i++)
				newdata[i] = intdata[i];
			intdata = newdata; 
		} else {
			int[][] newdata = new int[arraydata.length*2][];
			for(int i = 0; i < pointer; i++)
				newdata[i] = arraydata[i];
			arraydata = newdata; 
		}
	}
	
	public int getLastInt(){
		return intdata[pointer-1];
	} 
	public int[] getLastAr(){
		return arraydata[pointer-1];
	} 
	
	public int removeLastInt(){
		pointer--; // this actually works noticably faster
		int r = intdata[pointer];
		return r;
		//return removeIntAt(pointer-1);
	}
	public int[] removeLastAr(){
		pointer--; // this actually works noticably faster
		int[] r = arraydata[pointer];
		return r;
		//return removeArAt(pointer-1);
	}

	public int removeIntAt(int index){
		pointer--;
		
		/*if(pointer == intdata.length/4){
			int[] newdata = new int[intdata.length/2];
			for(int i = 0; i < pointer; i++)
				newdata[i] = i<index?intdata[i]:intdata[i+1];
				intdata = newdata;
		} else if(index != pointer) 
			for(int i = index; i < pointer; i++)
				intdata[i] = intdata[i+1];
		*/
		if(index != pointer){
			int r = intdata[index];
			for(int i = index; i < pointer; i++)
				intdata[i] = intdata[i+1];
			return r;
		}
		return intdata[index];
	}
	public int[] removeArAt(int index){
		pointer--;
		if(index != pointer){
			int[] r = arraydata[index];
			for(int i = index; i < pointer; i++)
				arraydata[i] = arraydata[i+1];
			return r;
		}
		return arraydata[index];
	}
	
	public String toString(){
		String s = "[";
		for(int i = 0; i < pointer; i++){
			s+=isInt?intdata[i]:arraydata[i];
			if(i < pointer-1)s+=",";
		}
		return s+"]";
	}
	
	public void clear(){
		pointer = 0;
	}
	
	public void addAllInt(PrimIntArrayList other){
		while(other.pointer+pointer>=intdata.length)resize(); // resize until the other fits in
		for(int i = 0; i < other.pointer; i++)
			intdata[pointer+i] = other.intdata[i];
		pointer += other.pointer;
	}
	public void addAllAr(PrimIntArrayList other){
		while(other.pointer+pointer>=arraydata.length)resize(); // resize until the other fits in
		for(int i = 0; i < other.pointer; i++)
			arraydata[pointer+i] = other.arraydata[i];
		pointer += other.pointer;
	}
	
	public boolean isEmpty(){
		return pointer == 0;
	}
}
