package aplprolog.prolog.builtins;

import aplprolog.datastructures.PrimIntKeyHashMap;
import aplprolog.prolog.BuiltIn;
import aplprolog.prolog.IntHarvester;

public class ExternalActions {
	public BuiltIn bi;
	public int[] intResult = null;
	public Object[] objResult = null;
	PrimIntKeyHashMap<ExternalTool> tools = new PrimIntKeyHashMap<ExternalTool>(PrimIntKeyHashMap.OBJ);
	PrimIntKeyHashMap<PrimIntKeyHashMap<int[]>> actions = new PrimIntKeyHashMap<PrimIntKeyHashMap<int[]>>(PrimIntKeyHashMap.OBJ);
	public static final int INTAR = 0, OBJECTS = 1;
	public ExternalActions(BuiltIn bi){
		this.bi = bi;
	}
	
	public boolean call(int[] inputcall, boolean doReturn){
		int[] ar = bi.rulemods.deepcopy(inputcall, 0, bi.p.harvester.scanElement(inputcall, 0, false, false));
		//System.out.println(bi.p.harvester.arToString(ar, false)); //Topic=fine, Msg= 'test msg', Tool=gui,Call=show_notice(Topic,Msg),@external(Tool,Call,R)
		int toolID = ar[4];
		ExternalTool tool = tools.getObj(toolID);
		if(tool==null)return false;
		int[] call = ar;
		int c = bi.p.harvester.scanElement(ar, 3, false, false);
		int c2 = doReturn?bi.p.harvester.scanElement(ar, c, false, false):0; // cursor return type
		int actionID = ar[c+1]; 
		int[] types = actions.getObj(toolID).getObj(actionID);
		if(types[0]==INTAR)tool.handleCall(bi.rulemods.deepcopy(call, c, bi.p.harvester.scanElement(call, c, false, false)), this, types[1]);
		else { System.out.println("TODO: Implement external call that is called using objects."); }
		if(doReturn){
			if(types[1]==INTAR) return bi.p.harvester.unifyTerm(inputcall, intResult, bi.p.harvester.scanElement(inputcall, bi.p.harvester.scanElement(inputcall, 3, false, false), false, false), 0, false, false); // return the unification
			else System.out.println("TODO: Implement external call that returns objects.");
		}
		return true;
	}
	
	public void registerAction(String action, ExternalTool tool, int callType, int returnType){
		Integer actionID = bi.p.strStorage.getInt(action);
		if(actionID == null) actionID = bi.p.strStorage.add(action);
		Integer toolID = bi.p.strStorage.getInt(tool.getName());
		if(toolID == null) toolID = bi.p.strStorage.add(tool.getName());
		tools.putObj(toolID, tool);
		PrimIntKeyHashMap<int[]> toolMap = actions.getObj(toolID);
		if(toolMap == null){
			toolMap = new PrimIntKeyHashMap<int[]>(PrimIntKeyHashMap.OBJ);
			actions.putObj(toolID, toolMap);
		}
		toolMap.putObj(actionID, new int[]{callType,returnType});
	}
}
