package oopl.GUI;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import oopl.DistributedOOPL;
import oopl.OOPL;

public class Model extends JPanel implements KeyListener{
	JComponent environment;
	JPanel sendEvent;
	JTextField eventField = new JTextField();
	ArrayList<String> history = new ArrayList<String>();// history of queries
	int historyC = 0;
	DistributedOOPL oopl;
	
	public Model(DistributedOOPL oopl, JComponent environment){
		super(new BorderLayout());
		setBackground(Color.white);
		
		this.oopl = oopl;
		
		if(environment==null){
			environment = new JPanel(new FlowLayout());
			environment.add(new JLabel("<html><h1>No environment model was given.</h1></html>"));
		} else this.environment = environment;
		
		// send event panel
		GridBagLayout gl = new GridBagLayout();
		GridBagConstraints fieldConstraints = new GridBagConstraints(); // some constraints for good resizing
		fieldConstraints.fill = GridBagConstraints.HORIZONTAL;
		fieldConstraints.anchor = GridBagConstraints.NORTHWEST;
		fieldConstraints.weightx = 1.0;
		fieldConstraints.gridwidth = GridBagConstraints.REMAINDER;
		fieldConstraints.insets = new Insets(1, 1, 1, 1);
		GridBagConstraints labelConstraints = (GridBagConstraints) fieldConstraints.clone();
		labelConstraints.weightx = 0.0;
		labelConstraints.gridwidth = 1;
		eventField.addKeyListener(this);
		sendEvent = new JPanel(gl);
		sendEvent.add(new JLabel("Manual event: "),labelConstraints);
		sendEvent.add(eventField,fieldConstraints);
		sendEvent.setMinimumSize(new Dimension(30, 30));
		
		add(environment,BorderLayout.CENTER);
		add(sendEvent,BorderLayout.SOUTH);
	}
	 
		public void keyTyped(KeyEvent e) {}
	 
		public void keyPressed(KeyEvent e) {}
	 
		public void keyReleased(KeyEvent e) { 
			if(e.getKeyCode() == KeyEvent.VK_ENTER){
				String q = eventField.getText();
				if(!q.endsWith(".")) q = q + "."; 
				if(historyC!=history.size())history.remove(historyC);
				history.add(q); 
				historyC = history.size();
				oopl.handleEvent(oopl.getProlog().mp.parseFact(q,oopl.getProlog().strStorage,false),false);
				eventField.setText(""); 
			} else if(e.getKeyCode() == KeyEvent.VK_UP){
				historyC = Math.max(historyC-1, 0);
				eventField.setText(history.get(historyC));
			} else if(e.getKeyCode() == KeyEvent.VK_DOWN){
				historyC = Math.min(historyC+1,history.size());
				eventField.setText((historyC==history.size()?"":history.get(historyC)));
			}
		}
}
