package oopl.GUI;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.UnknownHostException;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.border.LineBorder;
import javax.swing.plaf.OptionPaneUI;

import networkConnection.ClientMessageHandler;
import networkConnection.Server;


import oopl.OOPLNetworkListener;
import oopl.OOPLNetworkNode;
/*
 * Start/stop server.
 * Server port.
 * Lijst met available adressen, + send message lbl & field, + area for test result
 * Label met local ip adres.
 * Strings gaan naar de area, int[]'s zijn events. Ik kan een built-in effect rule achtig iets maken om deze events te handlen.
 */
public class Network extends JPanel implements KeyListener, ActionListener, OOPLNetworkListener{
	JTextField jtfPort, jtfMessage, jtfNewContact, jtfRecipient;
	JButton jbtnSend, jbtnAddContact, jbtnDeleteContact, jbtnShowInterfaces;
	JToggleButton jtbtnConnect;
	boolean connected = false;
	JComboBox jcbRecipients, jcbContacts;
	Vector<String> contacts;
	JTextArea jtaMessages;
	OOPLNetworkNode ooplNN;

	public Network(OOPLNetworkNode ooplNN, int port){
		super(new BorderLayout());
		this.ooplNN = ooplNN;
		ooplNN.addNetworkListener(this);
		
		jtfPort = new JTextField(""+port);
		jtfMessage = new JTextField("Hello 2OPL interpreter!");
		jtfNewContact = new JTextField("255.255.255.255");
		jtfRecipient = new JTextField("255.255.255.255");
		jtbtnConnect = new JToggleButton("Connect server");
		jtbtnConnect.addActionListener(this);
		jbtnAddContact = new JButton("Add contact");
		jbtnDeleteContact = new JButton("Delete contact");
		jbtnSend = new JButton("Send");
		jbtnShowInterfaces = new JButton("Show network interfaces");

		contacts = new Vector<String>();
		contacts.add("localhost:"+port);

		jcbRecipients = new JComboBox(contacts);
		jcbContacts = new JComboBox(contacts);
		jtaMessages = new JTextArea("Messages:\r\n");
		JLabel localIP = new JLabel("0.0.0.0");
		try{localIP = new JLabel(InetAddress.getLocalHost().getHostAddress());}catch(UnknownHostException e){e.printStackTrace();}
		
		jbtnAddContact.addActionListener(this);
		jbtnDeleteContact.addActionListener(this);
		jbtnSend.addActionListener(this);
		jcbRecipients.addActionListener(this);
		jcbContacts.addActionListener(this);
		jbtnShowInterfaces.addActionListener(this);
		
		// IP, port and connected:
		JPanel jpnlStatus = new JPanel(new GridLayout(4,2));
		jpnlStatus.add(new JLabel("Server connection settings: ")); jpnlStatus.add(new JLabel(""));
		jpnlStatus.add(new JLabel("Localhost IP adress: "));
		jpnlStatus.add(localIP);
		jpnlStatus.add(new JLabel("Port: "));
		jpnlStatus.add(jtfPort);
		jpnlStatus.add(jtbtnConnect);
		jpnlStatus.add(jbtnShowInterfaces);
		
		// Contacts
		JPanel jpnlContacts = new JPanel(new FlowLayout(FlowLayout.LEFT));
		jpnlContacts.add(new JLabel("Available contacts: "));
		jpnlContacts.add(jcbContacts);
		jpnlContacts.add(jtfNewContact);
		jpnlContacts.add(jbtnAddContact);
		jpnlContacts.add(jbtnDeleteContact);
		
		JPanel top = new JPanel(new BorderLayout());
		
		top.add(jpnlStatus,BorderLayout.WEST);
		top.add(jpnlContacts,BorderLayout.SOUTH);
		add(top,BorderLayout.NORTH);
		
		JScrollPane jspMessage = new JScrollPane(jtaMessages);
		add(jspMessage,BorderLayout.CENTER);
		
		// Send a message:
		GridBagLayout gl = new GridBagLayout();
		GridBagConstraints fieldConstraints = new GridBagConstraints(); // some constraints for good resizing
		fieldConstraints.fill = GridBagConstraints.HORIZONTAL;
		fieldConstraints.anchor = GridBagConstraints.NORTHWEST;
		fieldConstraints.weightx = 1.0;
		fieldConstraints.gridwidth = GridBagConstraints.REMAINDER;
		fieldConstraints.insets = new Insets(1, 1, 1, 1);
		GridBagConstraints labelConstraints = (GridBagConstraints) fieldConstraints.clone();
		labelConstraints.weightx = 0.0;
		labelConstraints.gridwidth = 1;
		GridBagConstraints midConstraints = (GridBagConstraints) fieldConstraints.clone();
		midConstraints.weightx = 1.0;
		midConstraints.gridwidth = GridBagConstraints.RELATIVE;
		GridBagConstraints endConstraints = (GridBagConstraints) fieldConstraints.clone();
		endConstraints.weightx = 0.0;
		JPanel jpnlSend = new JPanel(gl);
		jpnlSend.add(new JLabel("Recipient: "),labelConstraints);
		jpnlSend.add(jcbRecipients,labelConstraints);
		jpnlSend.add(jtfRecipient,labelConstraints);
		jpnlSend.add(jtfMessage,midConstraints);
		jpnlSend.add(jbtnSend, endConstraints);
		jpnlSend.setMinimumSize(new Dimension(30, 30));
		
		add(jpnlSend,BorderLayout.SOUTH);
		
	}
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == jtbtnConnect){
			makeConnection();
		} else if(e.getSource() == jcbContacts){
			jtfNewContact.setText((String)jcbContacts.getSelectedItem());
		} else if(e.getSource() == jbtnAddContact){
			contacts.add(jtfNewContact.getText());
			jcbContacts.updateUI();
			jcbRecipients.updateUI();
		} else if(e.getSource() == jbtnDeleteContact){
			contacts.remove(jtfNewContact.getText());
			jcbRecipients.updateUI();
			jcbContacts.updateUI();
		} else if(e.getSource() == jcbRecipients){
			jtfRecipient.setText((String)jcbRecipients.getSelectedItem());
		} else if(e.getSource() == jbtnSend){
			String[] parts =jtfRecipient.getText().split(":");
			ooplNN.server.sendMessage(jtfMessage.getText(),parts[0], Integer.parseInt(parts[1]), true, true);
		} else if (e.getSource() == jbtnShowInterfaces){
			showInterfaces();
		}
	}
	public void hitConnect(){
		jtbtnConnect.doClick();
	}
	public void makeConnection(){
		jtbtnConnect.setText((jtbtnConnect.isSelected()?"Disconnect server":"Connect server"));
		if(jtbtnConnect.isSelected()){
			ooplNN.server = new Server(Integer.parseInt(jtfPort.getText()), ooplNN);
			ooplNN.server.addListener(ooplNN);
			ooplNN.server.start();
		} else {
			ooplNN.server.disconnectServer();
		}
	}
	public void keyTyped(KeyEvent e) {
	}
	public void keyPressed(KeyEvent e) {
	}
	public void keyReleased(KeyEvent e) {
	}
	
	public void notifyMessageTransfer(String date, String from, String to, String message, boolean received) {
		jtaMessages.append(date+": "+(received?"Received":"Send")+" \""+message+"\" from "+from+" to "+to+"\r\n");		
	}
	
	public void notifyOverheadEvent(String date, String event) {
		jtaMessages.append(date+": "+event+"\r\n");
	}
	
	public void showInterfaces(){
		String s = "All the interfaces which have one or more addresses:\r\n";
		try{
		Enumeration<NetworkInterface> eni = NetworkInterface.getNetworkInterfaces();
		while(eni.hasMoreElements()){
			NetworkInterface ni = eni.nextElement(); 
			Enumeration<InetAddress> ena = ni.getInetAddresses();
			if(ena.hasMoreElements()){
				s += "Inteface name: "+ni.getDisplayName()+"\r\n";
				while(ena.hasMoreElements()){
					InetAddress ia = ena.nextElement();
					s += "  -"+ia.getHostName() + " "+ia.getHostAddress()+"\r\n";
				}
			}
		}
		} catch(Exception e){ s = "Error while looking for network interfaces."; }
		JTextArea jta = new JTextArea(s);
		JScrollPane jsp = new JScrollPane(jta);
		JOptionPane.showMessageDialog(null, jsp, "Network interfaces", JOptionPane.PLAIN_MESSAGE, null);
	}

}
