package oopl.GUI;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class TexBuilder {
	public String format = "./logs/LogFormat.txt";
	public String goal = "./logs/log.tex";
	public String beforeEvents="",betweenEventsAndNetwork="",betweenNetworkAndProlog="",
			prologBeginTable="",prologEndTable="",lastpart="";
	
	public TexBuilder(){
		loadTexts();
	}
	
	public void generateLog(Monitor m){
		 String r = beforeEvents;
		 for(String e : m.eventEntries) r += e;
		 r += betweenEventsAndNetwork;
		 for(String n : m.networkEntries) r += n;
		 r += betweenNetworkAndProlog;
		 for(String p : m.prologEntries) r += "\\clearpage \r\n" + p;
		 r += "\r\n"+lastpart;
		 try{
			 BufferedWriter bw = new BufferedWriter(new FileWriter(goal)); 
			 bw.write(r);
			 bw.flush();
			 bw.close();
		 } catch(Exception e){System.out.println(e);}
	}
	
	public void loadTexts(){
		try{
			BufferedReader br = new BufferedReader(new FileReader(format));
			String line = "";
			int status = 0;
			while((line = br.readLine()) != null){
				if(line.startsWith("status++")){
					status++;
				} else {
					line = line.replaceAll("\\n", ""); // strip away line endings
					line = line.replaceAll("\\r", "");
					if(status == 0) beforeEvents += line+"\r\n";
					else if(status == 1) betweenEventsAndNetwork += line+"\r\n";
					else if(status == 2) betweenNetworkAndProlog += line+"\r\n";
					else if(status == 3) prologBeginTable += line+"\r\n";
					else if(status == 4) prologEndTable += line+"\r\n";
					else if(status == 5) lastpart += line+"\r\n";
				}
			}
			br.close();
		}catch(Exception e){
			System.out.println(e);
		}
	}
	
	public String tablerow(String a, String b, String c, String d){
		return a+"&\\texttt{"+b+"}&"+c+"&"+d+"\\\\ [1ex] \\hline";
	}
	public int commando(String c){
		try {
			Runtime rt = Runtime.getRuntime();
			//Process pr = rt.exec("cmd /c dir");
			//Process pr = rt.exec("cmd /c texworks naamloos-1.pdf");
			Process pr = rt.exec("cmd /c "+c);
			//pr = rt.exec("cmd /c naamloos-1.pdf");

			BufferedReader input = new BufferedReader(new InputStreamReader(pr.getInputStream()));

			String line=null;
			while((line=input.readLine()) != null) {
				System.out.println(line);
			}

			int exitVal = pr.waitFor();
			System.out.println("Exited with error code "+exitVal);

		} catch(Exception e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
		return 0;
	}
}
