/* Generated By:JavaCC: Do not edit this line. IntOOPL.java */
package oopl.parsing;
import java.io.StringReader;
import java.util.HashMap;
import aplprolog.datastructures.PrimIntArrayList;
import aplprolog.datastructures.PrimIntKeyHashMap;
import aplprolog.prolog.IntHarvester;
import aplprolog.prolog.StringStorage;
import aplprolog.prolog.Prolog;
/**
 * The parser to convert <code>String</code> objects to integer arrays. Viewing the "oopl.jj" file is advised. 
 * 
 * @author Bas Testerink, Utrecht University, The Netherlands
 * 
 */
public class IntOOPL implements IntOOPLConstants {
        public PrologToInts pti;
        public DooplToInts dti;
        public OoplToInts oti;
 /** Main entry point. Contains now solely some testing code. */
  public static void main(String args[]) throws ParseException {
    IntOOPL parser = new IntOOPL(System.in);
    Prolog p = new Prolog();
    PrologToInts pti = new PrologToInts(p.strStorage);
    parser.pti = pti;
    parser.dti = new DooplToInts(pti);
    parser.oti = new OoplToInts(pti);
    parser.COMBI();
  }

  public void initToInts(){
        Prolog p = new Prolog();
        pti = new PrologToInts(p.strStorage);
        dti = new DooplToInts(pti);
        oti = new OoplToInts(pti);
        pti.new_base();
  }

  /**
  * Parse a term/fact.
  * @param f Fact to be parsed.
  * @param strStor String mapping.
  */
   public int[] parseFact(String f, StringStorage strStor){
        try{
                if(pti==null) initToInts();
        pti.clear_overhead();
                pti.strStor = strStor;
                ReInit(new StringReader(f));
                Rule(); // parse it
                pti.addVarOverhead(); // add overhead integers
                pti.addSplitsOverhead();
                return pti.getPrimArray(0); // return result
        }catch(ParseException e){System.out.println(e);}
        return null;
  }

  /**
  * Parse a collection of facts/rules/norms.
  * @param strStor String mapping.
  */
  public void parseOOPLConfiguration(StringStorage strStor, String type){
    if(pti==null) initToInts();
    pti.strStor = strStor;
        try{
                if(type.equals("COMBI")) COMBI();
                else if(type.equals("DOOPL")) DOOPL();
                else if(type.equals("OOPL")) OOPL();
                else if(type.equals("PROLOG")) Prolog();
        }catch(ParseException e){System.out.println(e);}
  }

//////////////
/// Prolog ///
//////////////
  final public void Argument() throws ParseException {
    if (jj_2_1(2147483647)) {
      Infix();
    } else if (jj_2_2(2147483647)) {
      Number();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHARACTER_LITERAL:
      case STD_IDENTIFIER:
      case SEMICOLON:
      case NOTSPACE:
      case ADD:
      case SUBTRACT:
      case IMPLY:
      case MULTIPLY:
      case POWER:
      case DIVIDE:
      case BITAND:
      case UNIFICATION:
      case ARITHUNIF:
      case ARITHNOTUNIF:
      case EQLT:
      case TERMDECOMPOSITION:
      case EQUALS:
      case BACKSLASH:
      case NOT:
      case BITOR:
      case NOTUNIFIABLE:
      case NOTEQUALS:
      case TERMGTEQ:
      case TERMEQLT:
      case TERMLT:
      case TERMGT:
      case TERMEQ:
      case TERMNEQ:
      case LT:
      case SHIFTLEFT:
      case GT:
      case SHIFTRIGHT:
      case GTEQ:
      case ASSIGN:
      case POWER2:
      case XOR:
      case REMAINDER:
      case INTDIVIDE:
      case MODULO:
      case COLON:
        Predicate();
        break;
      case LPAREN:
        Parenthesized();
        break;
      case BANG:
        Cut();
        break;
      case VAR_IDENTIFIER:
        Var();
        break;
      case LBRACKET:
        List();
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

// Number
  final public void Number() throws ParseException {
 Token n; double m = 1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUBTRACT:
      jj_consume_token(SUBTRACT);
                     m=-1d;
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      n = jj_consume_token(INTEGER_LITERAL);
      break;
    case FLOATING_POINT_LITERAL:
      n = jj_consume_token(FLOATING_POINT_LITERAL);
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
         pti.new_num(n,m);
  }

  final public void Predicate() throws ParseException {
 Token h; int counter = 0; int curSize = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NOTSPACE:
    case NOT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NOT:
        jj_consume_token(NOT);
        break;
      case NOTSPACE:
        jj_consume_token(NOTSPACE);
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                             curSize = pti.new_predicate("not"); pti.replace(curSize,1);
      Predicate();
      break;
    default:
      jj_la1[8] = jj_gen;
      if (jj_2_3(2)) {
        jj_consume_token(SUBTRACT);
                     curSize = pti.new_predicate("-"); pti.replace(curSize,1);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case SEMICOLON:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          Predicate();
          break;
        case VAR_IDENTIFIER:
          Var();
          break;
        default:
          jj_la1[4] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case SEMICOLON:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case STD_IDENTIFIER:
            h = jj_consume_token(STD_IDENTIFIER);
            break;
          case CHARACTER_LITERAL:
            h = jj_consume_token(CHARACTER_LITERAL);
            break;
          case SEMICOLON:
          case ADD:
          case SUBTRACT:
          case IMPLY:
          case MULTIPLY:
          case POWER:
          case DIVIDE:
          case BITAND:
          case UNIFICATION:
          case ARITHUNIF:
          case ARITHNOTUNIF:
          case EQLT:
          case TERMDECOMPOSITION:
          case EQUALS:
          case BACKSLASH:
          case BITOR:
          case NOTUNIFIABLE:
          case NOTEQUALS:
          case TERMGTEQ:
          case TERMEQLT:
          case TERMLT:
          case TERMGT:
          case TERMEQ:
          case TERMNEQ:
          case LT:
          case SHIFTLEFT:
          case GT:
          case SHIFTRIGHT:
          case GTEQ:
          case ASSIGN:
          case POWER2:
          case XOR:
          case REMAINDER:
          case INTDIVIDE:
          case MODULO:
          case COLON:
            h = Operator();
            break;
          default:
            jj_la1[5] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
         curSize = pti.new_predicate(h.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            jj_consume_token(LPAREN);
            Argument();
                              counter++;
            label_1:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[6] = jj_gen;
                break label_1;
              }
              jj_consume_token(COMMA);
              Argument();
                                                              counter++;
            }
            jj_consume_token(RPAREN);
            break;
          default:
            jj_la1[7] = jj_gen;
            ;
          }
         pti.replace(curSize,counter);
          break;
        default:
          jj_la1[9] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

  final public Token Operator() throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ADD:
      t = jj_consume_token(ADD);
      break;
    case SUBTRACT:
      t = jj_consume_token(SUBTRACT);
      break;
    case IMPLY:
      t = jj_consume_token(IMPLY);
      break;
    case MULTIPLY:
      t = jj_consume_token(MULTIPLY);
      break;
    case POWER:
      t = jj_consume_token(POWER);
      break;
    case DIVIDE:
      t = jj_consume_token(DIVIDE);
      break;
    case BITAND:
      t = jj_consume_token(BITAND);
      break;
    case UNIFICATION:
      t = jj_consume_token(UNIFICATION);
      break;
    case ARITHUNIF:
      t = jj_consume_token(ARITHUNIF);
      break;
    case ARITHNOTUNIF:
      t = jj_consume_token(ARITHNOTUNIF);
      break;
    case EQLT:
      t = jj_consume_token(EQLT);
      break;
    case TERMDECOMPOSITION:
      t = jj_consume_token(TERMDECOMPOSITION);
      break;
    case EQUALS:
      t = jj_consume_token(EQUALS);
      break;
    case BACKSLASH:
      t = jj_consume_token(BACKSLASH);
      break;
    case BITOR:
      t = jj_consume_token(BITOR);
      break;
    case NOTUNIFIABLE:
      t = jj_consume_token(NOTUNIFIABLE);
      break;
    case NOTEQUALS:
      t = jj_consume_token(NOTEQUALS);
      break;
    case TERMGTEQ:
      t = jj_consume_token(TERMGTEQ);
      break;
    case TERMEQLT:
      t = jj_consume_token(TERMEQLT);
      break;
    case TERMLT:
      t = jj_consume_token(TERMLT);
      break;
    case TERMGT:
      t = jj_consume_token(TERMGT);
      break;
    case TERMEQ:
      t = jj_consume_token(TERMEQ);
      break;
    case TERMNEQ:
      t = jj_consume_token(TERMNEQ);
      break;
    case LT:
      t = jj_consume_token(LT);
      break;
    case SHIFTLEFT:
      t = jj_consume_token(SHIFTLEFT);
      break;
    case GT:
      t = jj_consume_token(GT);
      break;
    case SHIFTRIGHT:
      t = jj_consume_token(SHIFTRIGHT);
      break;
    case GTEQ:
      t = jj_consume_token(GTEQ);
      break;
    case ASSIGN:
      t = jj_consume_token(ASSIGN);
      break;
    case POWER2:
      t = jj_consume_token(POWER2);
      break;
    case XOR:
      t = jj_consume_token(XOR);
      break;
    case REMAINDER:
      t = jj_consume_token(REMAINDER);
      break;
    case INTDIVIDE:
      t = jj_consume_token(INTDIVIDE);
      break;
    case MODULO:
      t = jj_consume_token(MODULO);
      break;
    case COLON:
      t = jj_consume_token(COLON);
      break;
    case SEMICOLON:
      t = jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
         {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public void Bodypart() throws ParseException {
    if (jj_2_4(2147483647)) {
      Infix();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHARACTER_LITERAL:
      case STD_IDENTIFIER:
      case SEMICOLON:
      case NOTSPACE:
      case ADD:
      case SUBTRACT:
      case IMPLY:
      case MULTIPLY:
      case POWER:
      case DIVIDE:
      case BITAND:
      case UNIFICATION:
      case ARITHUNIF:
      case ARITHNOTUNIF:
      case EQLT:
      case TERMDECOMPOSITION:
      case EQUALS:
      case BACKSLASH:
      case NOT:
      case BITOR:
      case NOTUNIFIABLE:
      case NOTEQUALS:
      case TERMGTEQ:
      case TERMEQLT:
      case TERMLT:
      case TERMGT:
      case TERMEQ:
      case TERMNEQ:
      case LT:
      case SHIFTLEFT:
      case GT:
      case SHIFTRIGHT:
      case GTEQ:
      case ASSIGN:
      case POWER2:
      case XOR:
      case REMAINDER:
      case INTDIVIDE:
      case MODULO:
      case COLON:
        Predicate();
        break;
      case LPAREN:
        Parenthesized();
        break;
      case BANG:
        Cut();
        break;
      case VAR_IDENTIFIER:
        Var();
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void Infix() throws ParseException {
 int curSize; Token o;
         curSize = pti.new_predicate("_");
    if (jj_2_5(2147483647)) {
      Number();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHARACTER_LITERAL:
      case STD_IDENTIFIER:
      case SEMICOLON:
      case NOTSPACE:
      case ADD:
      case SUBTRACT:
      case IMPLY:
      case MULTIPLY:
      case POWER:
      case DIVIDE:
      case BITAND:
      case UNIFICATION:
      case ARITHUNIF:
      case ARITHNOTUNIF:
      case EQLT:
      case TERMDECOMPOSITION:
      case EQUALS:
      case BACKSLASH:
      case NOT:
      case BITOR:
      case NOTUNIFIABLE:
      case NOTEQUALS:
      case TERMGTEQ:
      case TERMEQLT:
      case TERMLT:
      case TERMGT:
      case TERMEQ:
      case TERMNEQ:
      case LT:
      case SHIFTLEFT:
      case GT:
      case SHIFTRIGHT:
      case GTEQ:
      case ASSIGN:
      case POWER2:
      case XOR:
      case REMAINDER:
      case INTDIVIDE:
      case MODULO:
      case COLON:
        Predicate();
        break;
      case LPAREN:
        Parenthesized();
        break;
      case BANG:
        Cut();
        break;
      case VAR_IDENTIFIER:
        Var();
        break;
      case LBRACKET:
        List();
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    o = Operator();
    Argument();
         pti.replace(curSize-1,pti.strID(o.image));
         pti.replace(curSize,2);
  }

  final public void List() throws ParseException {
 int curSize=0; int counter=0;
         curSize = pti.new_list();
    jj_consume_token(LBRACKET);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STD_IDENTIFIER:
    case VAR_IDENTIFIER:
    case LPAREN:
    case LBRACKET:
    case SEMICOLON:
    case BANG:
    case NOTSPACE:
    case ADD:
    case SUBTRACT:
    case IMPLY:
    case MULTIPLY:
    case POWER:
    case DIVIDE:
    case BITAND:
    case UNIFICATION:
    case ARITHUNIF:
    case ARITHNOTUNIF:
    case EQLT:
    case TERMDECOMPOSITION:
    case EQUALS:
    case BACKSLASH:
    case NOT:
    case BITOR:
    case NOTUNIFIABLE:
    case NOTEQUALS:
    case TERMGTEQ:
    case TERMEQLT:
    case TERMLT:
    case TERMGT:
    case TERMEQ:
    case TERMNEQ:
    case LT:
    case SHIFTLEFT:
    case GT:
    case SHIFTRIGHT:
    case GTEQ:
    case ASSIGN:
    case POWER2:
    case XOR:
    case REMAINDER:
    case INTDIVIDE:
    case MODULO:
    case COLON:
      Argument();
                               counter++;
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    counter = ListRest(counter);
         pti.finish_list(curSize,counter);
  }

  final public int ListRest(int before) throws ParseException {
 int counter=0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BAR:
      Tail();
      jj_consume_token(RBRACKET);
                            {if (true) return before*-1;}
      break;
    case COMMA:
      jj_consume_token(COMMA);
      Argument();
      counter = ListRest(before+1);
                                                        {if (true) return counter;}
      break;
    case RBRACKET:
      jj_consume_token(RBRACKET);
                     {if (true) return before;}
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void Tail() throws ParseException {
    jj_consume_token(BAR);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACKET:
      List();
      break;
    case VAR_IDENTIFIER:
      Var();
      break;
    default:
      jj_la1[15] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void Parenthesized() throws ParseException {
 int counter = 0; int curSize = 0;
         curSize=pti.new_parenthesized();
    jj_consume_token(LPAREN);
    Argument();
                             counter++;
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[16] = jj_gen;
        break label_2;
      }
      jj_consume_token(COMMA);
      Argument();
                                                             counter++;
    }
    jj_consume_token(RPAREN);
         pti.replace(curSize,counter);
  }

  final public void Var() throws ParseException {
 Token t;
    t = jj_consume_token(VAR_IDENTIFIER);
         pti.handle_var(t.image);
  }

  final public void Cut() throws ParseException {
    jj_consume_token(BANG);
                pti.new_cut();
  }

  final public void Rule() throws ParseException {
    Predicate();
                     pti.add_split();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      jj_consume_token(SUBTRACT);
      Bodypart();
                                       pti.add_split();
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[17] = jj_gen;
          break label_3;
        }
        jj_consume_token(COMMA);
        Bodypart();
                             pti.add_split();
      }
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    jj_consume_token(DOT);
  }

  final public void Prolog() throws ParseException {
 pti.new_base();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHARACTER_LITERAL:
      case STD_IDENTIFIER:
      case SEMICOLON:
      case NOTSPACE:
      case ADD:
      case SUBTRACT:
      case IMPLY:
      case MULTIPLY:
      case POWER:
      case DIVIDE:
      case BITAND:
      case UNIFICATION:
      case ARITHUNIF:
      case ARITHNOTUNIF:
      case EQLT:
      case TERMDECOMPOSITION:
      case EQUALS:
      case BACKSLASH:
      case NOT:
      case BITOR:
      case NOTUNIFIABLE:
      case NOTEQUALS:
      case TERMGTEQ:
      case TERMEQLT:
      case TERMLT:
      case TERMGT:
      case TERMEQ:
      case TERMNEQ:
      case LT:
      case SHIFTLEFT:
      case GT:
      case SHIFTRIGHT:
      case GTEQ:
      case ASSIGN:
      case POWER2:
      case XOR:
      case REMAINDER:
      case INTDIVIDE:
      case MODULO:
      case COLON:
        ;
        break;
      default:
        jj_la1[19] = jj_gen;
        break label_4;
      }
      Rule();
                pti.add_rule();
    }
    jj_consume_token(0);
  }

////////////////////////////////
/// Distributed OOPL (DOOPL) ///
////////////////////////////////
  final public void DOOPL_Literal() throws ParseException {
 Token t=null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOLLAR:
      DOOPL_Label();
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    if (jj_2_6(2)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ADD:
        t = jj_consume_token(ADD);
        break;
      case SUBTRACT:
        t = jj_consume_token(SUBTRACT);
        break;
      default:
        jj_la1[21] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } else {
      ;
    }
                                              dti.wrap_literal(t);
    Predicate();
  }

  final public void DOOPL_Label() throws ParseException {
 Token t; boolean isVar = false;
    jj_consume_token(DOLLAR);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STD_IDENTIFIER:
      t = jj_consume_token(STD_IDENTIFIER);
      break;
    case CHARACTER_LITERAL:
      t = jj_consume_token(CHARACTER_LITERAL);
      break;
    case VAR_IDENTIFIER:
      t = jj_consume_token(VAR_IDENTIFIER);
                                                                               isVar=true;
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(COLON);
         dti.add_label(t.image,isVar);
  }

  final public void DOOPL_Bodypart() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOLLAR:
      DOOPL_Label();
      break;
    default:
      jj_la1[23] = jj_gen;
      ;
    }
    Bodypart();
  }

  final public void DOOPL_Update() throws ParseException {
 int counter = 0; int curSize = 0; int headStart = 0; int headEnd = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 78:
      jj_consume_token(78);
      break;
    case 79:
      jj_consume_token(79);
      jj_consume_token(LBRACE);
      break;
    default:
      jj_la1[24] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                 dti.new_update(); headStart = pti.array.pointer;
    jj_consume_token(80);
    Predicate();
    jj_consume_token(DOT);
                 headEnd = pti.array.pointer; curSize = pti.new_parenthesized();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 81:
      jj_consume_token(81);
                                  dti.inPre();
      DOOPL_Bodypart();
                                                                  counter++;
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[25] = jj_gen;
          break label_5;
        }
        jj_consume_token(COMMA);
        DOOPL_Bodypart();
                                                                                                         counter++;
      }
      jj_consume_token(DOT);
                                                                                                                              dti.outPre();
      break;
    default:
      jj_la1[26] = jj_gen;
      ;
    }
                 dti.end_parenthesized(curSize,counter,"true"); dti.shove_to_end(headStart,headEnd); curSize = pti.new_list(); counter = 0;
    jj_consume_token(82);
    DOOPL_Literal();
                                                  counter++;
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[27] = jj_gen;
        break label_6;
      }
      jj_consume_token(SEMICOLON);
      DOOPL_Literal();
                                                                                           counter++;
    }
    jj_consume_token(DOT);
                 pti.finish_list(curSize,counter);
    jj_consume_token(RBRACE);
         pti.fix_overhead(); pti.add_rule();
  }

  final public void DOOPL_Norm() throws ParseException {
 int counter = 0; int curSize = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 83:
      jj_consume_token(83);
      break;
    case 84:
      jj_consume_token(84);
      jj_consume_token(LBRACE);
      break;
    default:
      jj_la1[28] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                 dti.new_norm();
    jj_consume_token(85);
    Predicate();
    jj_consume_token(DOT);
                 curSize = pti.new_parenthesized();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 81:
      jj_consume_token(81);
                                  dti.inPre();
      DOOPL_Bodypart();
                                                                 counter++;
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[29] = jj_gen;
          break label_7;
        }
        jj_consume_token(COMMA);
        DOOPL_Bodypart();
                                                                                                       counter++;
      }
      jj_consume_token(DOT);
                                                                                                                            dti.outPre();
      break;
    default:
      jj_la1[30] = jj_gen;
      ;
    }
                 dti.end_parenthesized(curSize,counter,"true"); curSize = pti.new_parenthesized(); counter = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 86:
      jj_consume_token(86);
      DOOPL_Bodypart();
                                                 counter++;
      label_8:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[31] = jj_gen;
          break label_8;
        }
        jj_consume_token(COMMA);
        DOOPL_Bodypart();
                                                                                       counter++;
      }
      jj_consume_token(DOT);
      break;
    default:
      jj_la1[32] = jj_gen;
      ;
    }
                 dti.end_parenthesized(curSize,counter,"false"); curSize = pti.new_parenthesized(); counter = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 87:
      jj_consume_token(87);
      DOOPL_Bodypart();
                                                counter++;
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[33] = jj_gen;
          break label_9;
        }
        jj_consume_token(COMMA);
        DOOPL_Bodypart();
                                                                                      counter++;
      }
      jj_consume_token(DOT);
      break;
    default:
      jj_la1[34] = jj_gen;
      ;
    }
                 dti.end_parenthesized(curSize,counter,"false"); curSize = pti.new_parenthesized(); counter = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 88:
      jj_consume_token(88);
      DOOPL_Bodypart();
                                              counter++;
      label_10:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[35] = jj_gen;
          break label_10;
        }
        jj_consume_token(COMMA);
        DOOPL_Bodypart();
                                                                                    counter++;
      }
      jj_consume_token(DOT);
      break;
    default:
      jj_la1[36] = jj_gen;
      ;
    }
                 dti.end_parenthesized(curSize,counter,"false"); curSize = pti.new_parenthesized(); counter = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 89:
      jj_consume_token(89);
      DOOPL_Bodypart();
                                                counter++;
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[37] = jj_gen;
          break label_11;
        }
        jj_consume_token(COMMA);
        DOOPL_Bodypart();
                                                                                      counter++;
      }
      jj_consume_token(DOT);
      break;
    default:
      jj_la1[38] = jj_gen;
      ;
    }
                 dti.end_parenthesized(curSize,counter,"false"); curSize = pti.new_list(); counter = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 90:
      jj_consume_token(90);
      DOOPL_Literal();
                                             counter++;
      label_12:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[39] = jj_gen;
          break label_12;
        }
        jj_consume_token(SEMICOLON);
        DOOPL_Literal();
                                                                                      counter++;
      }
      jj_consume_token(DOT);
      break;
    default:
      jj_la1[40] = jj_gen;
      ;
    }
                 pti.finish_list(curSize,counter); curSize = pti.new_list(); counter = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 91:
      jj_consume_token(91);
      DOOPL_Literal();
                                           counter++;
      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[41] = jj_gen;
          break label_13;
        }
        jj_consume_token(SEMICOLON);
        DOOPL_Literal();
                                                                                    counter++;
      }
      jj_consume_token(DOT);
      break;
    default:
      jj_la1[42] = jj_gen;
      ;
    }
                 pti.finish_list(curSize,counter);
    jj_consume_token(RBRACE);
         pti.fix_overhead(); pti.add_rule();
  }

  final public void DOOPL() throws ParseException {
 pti.new_base();
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHARACTER_LITERAL:
      case STD_IDENTIFIER:
      case SEMICOLON:
      case NOTSPACE:
      case ADD:
      case SUBTRACT:
      case IMPLY:
      case MULTIPLY:
      case POWER:
      case DIVIDE:
      case BITAND:
      case UNIFICATION:
      case ARITHUNIF:
      case ARITHNOTUNIF:
      case EQLT:
      case TERMDECOMPOSITION:
      case EQUALS:
      case BACKSLASH:
      case NOT:
      case BITOR:
      case NOTUNIFIABLE:
      case NOTEQUALS:
      case TERMGTEQ:
      case TERMEQLT:
      case TERMLT:
      case TERMGT:
      case TERMEQ:
      case TERMNEQ:
      case LT:
      case SHIFTLEFT:
      case GT:
      case SHIFTRIGHT:
      case GTEQ:
      case ASSIGN:
      case POWER2:
      case XOR:
      case REMAINDER:
      case INTDIVIDE:
      case MODULO:
      case COLON:
      case 78:
      case 79:
      case 83:
      case 84:
        ;
        break;
      default:
        jj_la1[43] = jj_gen;
        break label_14;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 78:
      case 79:
        DOOPL_Update();
        break;
      case 83:
      case 84:
        DOOPL_Norm();
        break;
      case CHARACTER_LITERAL:
      case STD_IDENTIFIER:
      case SEMICOLON:
      case NOTSPACE:
      case ADD:
      case SUBTRACT:
      case IMPLY:
      case MULTIPLY:
      case POWER:
      case DIVIDE:
      case BITAND:
      case UNIFICATION:
      case ARITHUNIF:
      case ARITHNOTUNIF:
      case EQLT:
      case TERMDECOMPOSITION:
      case EQUALS:
      case BACKSLASH:
      case NOT:
      case BITOR:
      case NOTUNIFIABLE:
      case NOTEQUALS:
      case TERMGTEQ:
      case TERMEQLT:
      case TERMLT:
      case TERMGT:
      case TERMEQ:
      case TERMNEQ:
      case LT:
      case SHIFTLEFT:
      case GT:
      case SHIFTRIGHT:
      case GTEQ:
      case ASSIGN:
      case POWER2:
      case XOR:
      case REMAINDER:
      case INTDIVIDE:
      case MODULO:
      case COLON:
        Rule();
                                             pti.add_rule();
        break;
      default:
        jj_la1[44] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(0);
  }

/////////////////////
/// Original OOPL ///
/////////////////////
  final public void OOPL_Literal() throws ParseException {
 Token t = null;
    if (jj_2_7(2)) {
      t = jj_consume_token(NOTSPACE);
    } else {
      ;
    }
                                    dti.wrap_literal(t==null?new Token(0,"+"):new Token(0,"-"));
    Predicate();
  }

  final public void OOPL_Effect() throws ParseException {
 int curSize = 0; int counter = 0;
         dti.new_update(); curSize = pti.new_parenthesized();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      jj_consume_token(LBRACE);
      Bodypart();
                             counter++;
      label_15:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
        case NORMAND:
          ;
          break;
        default:
          jj_la1[45] = jj_gen;
          break label_15;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case NORMAND:
          jj_consume_token(NORMAND);
          break;
        case COMMA:
          jj_consume_token(COMMA);
          break;
        default:
          jj_la1[46] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        Bodypart();
                                                                         counter++;
      }
      jj_consume_token(RBRACE);
      break;
    default:
      jj_la1[47] = jj_gen;
      ;
    }
         dti.end_parenthesized(curSize,counter,"true"); counter = 0;
    Predicate();
         curSize = pti.new_list();
    jj_consume_token(LBRACE);
    OOPL_Literal();
                                counter++;
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
      case NORMAND:
        ;
        break;
      default:
        jj_la1[48] = jj_gen;
        break label_16;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NORMAND:
        jj_consume_token(NORMAND);
        break;
      case COMMA:
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[49] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      OOPL_Literal();
                                                                                counter++;
    }
    jj_consume_token(RBRACE);
         pti.finish_list(curSize,counter); pti.fix_overhead(); pti.add_rule();
  }

  final public void OOPL_Temporal() throws ParseException {
 int counter = 1; int curSize = 0; Token t; int headStart = 0; int headEnd = 0;
         dti.new_norm(); headStart = pti.array.pointer;
    Predicate();
    jj_consume_token(COLON);
    jj_consume_token(LBRACKET);
         headEnd = pti.array.pointer; curSize = pti.new_parenthesized(); pti.new_predicate("@countsas");
    Bodypart();
                   counter++;
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NORMAND:
        ;
        break;
      default:
        jj_la1[50] = jj_gen;
        break label_17;
      }
      jj_consume_token(NORMAND);
      Bodypart();
                                                     counter++;
    }
    jj_consume_token(COMMA);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 92:
      t = jj_consume_token(92);
      break;
    case 93:
      t = jj_consume_token(93);
      break;
    default:
      jj_la1[51] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
         dti.end_parenthesized(curSize,counter,"true"); counter = 0; curSize = pti.new_parenthesized();
    Bodypart();
                   counter++;
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NORMAND:
        ;
        break;
      default:
        jj_la1[52] = jj_gen;
        break label_18;
      }
      jj_consume_token(NORMAND);
      Bodypart();
                                                     counter++;
    }
    jj_consume_token(RPAREN);
    jj_consume_token(COMMA);
         dti.end_parenthesized(curSize,counter,"true"); oti.deontic(curSize,t); curSize = pti.new_parenthesized(); counter=0;
    Bodypart();
                   counter++;
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NORMAND:
        ;
        break;
      default:
        jj_la1[53] = jj_gen;
        break label_19;
      }
      jj_consume_token(NORMAND);
      Bodypart();
                                                     counter++;
    }
         dti.end_parenthesized(curSize,counter,"true"); oti.close_temporal(headStart,headEnd);
    jj_consume_token(RBRACKET);
         pti.fix_overhead(); pti.add_rule();
  }

  final public void OOPL_Imply(String type) throws ParseException {
 int counter = 2; int curSize = 0;
         oti.new_imply(); curSize = pti.new_parenthesized(); pti.new_predicate(type);
    Bodypart();
    label_20:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
      case NORMAND:
        ;
        break;
      default:
        jj_la1[54] = jj_gen;
        break label_20;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NORMAND:
        jj_consume_token(NORMAND);
        break;
      case COMMA:
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[55] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Bodypart();
                                                   counter++;
    }
         dti.end_parenthesized(curSize,counter,"true"); counter = 1; oti.middle_imply(); curSize = pti.new_list();
    jj_consume_token(NORMIMPLY);
    OOPL_Literal();
    label_21:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
      case NORMAND:
        ;
        break;
      default:
        jj_la1[56] = jj_gen;
        break label_21;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NORMAND:
        jj_consume_token(NORMAND);
        break;
      case COMMA:
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[57] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      OOPL_Literal();
                                                                       counter++;
    }
    jj_consume_token(DOT);
         pti.finish_list(curSize,counter); oti.finish_imply();
  }

  final public void OOPL() throws ParseException {
 pti.new_base();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 94:
      jj_consume_token(94);
      label_22:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case SEMICOLON:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          ;
          break;
        default:
          jj_la1[58] = jj_gen;
          break label_22;
        }
        Rule();
                          pti.add_rule();
      }
      break;
    default:
      jj_la1[59] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 95:
      jj_consume_token(95);
      label_23:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case LBRACE:
        case SEMICOLON:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          ;
          break;
        default:
          jj_la1[60] = jj_gen;
          break label_23;
        }
        OOPL_Effect();
      }
      break;
    default:
      jj_la1[61] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 96:
      jj_consume_token(96);
      label_24:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case VAR_IDENTIFIER:
        case LPAREN:
        case LBRACKET:
        case SEMICOLON:
        case BANG:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          ;
          break;
        default:
          jj_la1[62] = jj_gen;
          break label_24;
        }
        OOPL_Imply("@countsas");
      }
      break;
    default:
      jj_la1[63] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 97:
      jj_consume_token(97);
      label_25:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case SEMICOLON:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          ;
          break;
        default:
          jj_la1[64] = jj_gen;
          break label_25;
        }
        OOPL_Temporal();
      }
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 98:
      jj_consume_token(98);
      label_26:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case VAR_IDENTIFIER:
        case LPAREN:
        case LBRACKET:
        case SEMICOLON:
        case BANG:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          ;
          break;
        default:
          jj_la1[66] = jj_gen;
          break label_26;
        }
        OOPL_Imply("@sanction");
      }
      break;
    default:
      jj_la1[67] = jj_gen;
      ;
    }
    jj_consume_token(0);
  }

  final public void COMBI() throws ParseException {
 pti.new_base();
    label_27:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHARACTER_LITERAL:
      case STD_IDENTIFIER:
      case SEMICOLON:
      case NOTSPACE:
      case ADD:
      case SUBTRACT:
      case IMPLY:
      case MULTIPLY:
      case POWER:
      case DIVIDE:
      case BITAND:
      case UNIFICATION:
      case ARITHUNIF:
      case ARITHNOTUNIF:
      case EQLT:
      case TERMDECOMPOSITION:
      case EQUALS:
      case BACKSLASH:
      case NOT:
      case BITOR:
      case NOTUNIFIABLE:
      case NOTEQUALS:
      case TERMGTEQ:
      case TERMEQLT:
      case TERMLT:
      case TERMGT:
      case TERMEQ:
      case TERMNEQ:
      case LT:
      case SHIFTLEFT:
      case GT:
      case SHIFTRIGHT:
      case GTEQ:
      case ASSIGN:
      case POWER2:
      case XOR:
      case REMAINDER:
      case INTDIVIDE:
      case MODULO:
      case COLON:
        ;
        break;
      default:
        jj_la1[68] = jj_gen;
        break label_27;
      }
      Rule();
                pti.add_rule();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 94:
      jj_consume_token(94);
      label_28:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case SEMICOLON:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          ;
          break;
        default:
          jj_la1[69] = jj_gen;
          break label_28;
        }
        Rule();
                          pti.add_rule();
      }
      break;
    default:
      jj_la1[70] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 95:
      jj_consume_token(95);
      label_29:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case LBRACE:
        case SEMICOLON:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
        case 78:
        case 79:
          ;
          break;
        default:
          jj_la1[71] = jj_gen;
          break label_29;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case LBRACE:
        case SEMICOLON:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          OOPL_Effect();
          break;
        case 78:
        case 79:
          DOOPL_Update();
          break;
        default:
          jj_la1[72] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      break;
    default:
      jj_la1[73] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 99:
      jj_consume_token(99);
      label_30:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case VAR_IDENTIFIER:
        case LPAREN:
        case LBRACKET:
        case SEMICOLON:
        case BANG:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
        case 83:
        case 84:
          ;
          break;
        default:
          jj_la1[74] = jj_gen;
          break label_30;
        }
        if (jj_2_8(2147483647)) {
          OOPL_Temporal();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STD_IDENTIFIER:
          case VAR_IDENTIFIER:
          case LPAREN:
          case LBRACKET:
          case SEMICOLON:
          case BANG:
          case NOTSPACE:
          case ADD:
          case SUBTRACT:
          case IMPLY:
          case MULTIPLY:
          case POWER:
          case DIVIDE:
          case BITAND:
          case UNIFICATION:
          case ARITHUNIF:
          case ARITHNOTUNIF:
          case EQLT:
          case TERMDECOMPOSITION:
          case EQUALS:
          case BACKSLASH:
          case NOT:
          case BITOR:
          case NOTUNIFIABLE:
          case NOTEQUALS:
          case TERMGTEQ:
          case TERMEQLT:
          case TERMLT:
          case TERMGT:
          case TERMEQ:
          case TERMNEQ:
          case LT:
          case SHIFTLEFT:
          case GT:
          case SHIFTRIGHT:
          case GTEQ:
          case ASSIGN:
          case POWER2:
          case XOR:
          case REMAINDER:
          case INTDIVIDE:
          case MODULO:
          case COLON:
            OOPL_Imply("@countsas");
            break;
          case 83:
          case 84:
            DOOPL_Norm();
            break;
          default:
            jj_la1[75] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
      break;
    default:
      jj_la1[76] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 98:
      jj_consume_token(98);
      label_31:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STD_IDENTIFIER:
        case VAR_IDENTIFIER:
        case LPAREN:
        case LBRACKET:
        case SEMICOLON:
        case BANG:
        case NOTSPACE:
        case ADD:
        case SUBTRACT:
        case IMPLY:
        case MULTIPLY:
        case POWER:
        case DIVIDE:
        case BITAND:
        case UNIFICATION:
        case ARITHUNIF:
        case ARITHNOTUNIF:
        case EQLT:
        case TERMDECOMPOSITION:
        case EQUALS:
        case BACKSLASH:
        case NOT:
        case BITOR:
        case NOTUNIFIABLE:
        case NOTEQUALS:
        case TERMGTEQ:
        case TERMEQLT:
        case TERMLT:
        case TERMGT:
        case TERMEQ:
        case TERMNEQ:
        case LT:
        case SHIFTLEFT:
        case GT:
        case SHIFTRIGHT:
        case GTEQ:
        case ASSIGN:
        case POWER2:
        case XOR:
        case REMAINDER:
        case INTDIVIDE:
        case MODULO:
        case COLON:
          ;
          break;
        default:
          jj_la1[77] = jj_gen;
          break label_31;
        }
        OOPL_Imply("@sanction");
      }
      break;
    default:
      jj_la1[78] = jj_gen;
      ;
    }
    jj_consume_token(0);
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  private boolean jj_3_3() {
    if (jj_scan_token(SUBTRACT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_34()) {
    jj_scanpos = xsp;
    if (jj_3R_35()) return true;
    }
    return false;
  }

  private boolean jj_3R_69() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_44()) return true;
    return false;
  }

  private boolean jj_3R_41() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_35() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_40() {
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_68() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_61() {
    if (jj_3R_54()) return true;
    return false;
  }

  private boolean jj_3R_67() {
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_60() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_34() {
    if (jj_3R_46()) return true;
    return false;
  }

  private boolean jj_3R_53() {
    if (jj_scan_token(BANG)) return true;
    return false;
  }

  private boolean jj_3R_39() {
    if (jj_3R_52()) return true;
    return false;
  }

  private boolean jj_3R_59() {
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_80() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_47() {
    if (jj_scan_token(VAR_IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_66() {
    if (jj_3R_52()) return true;
    return false;
  }

  private boolean jj_3R_79() {
    if (jj_3R_54()) return true;
    return false;
  }

  private boolean jj_3R_52() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_44()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_69()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_38() {
    if (jj_3R_46()) return true;
    return false;
  }

  private boolean jj_3_8() {
    if (jj_3R_36()) return true;
    return false;
  }

  private boolean jj_3R_58() {
    if (jj_3R_52()) return true;
    return false;
  }

  private boolean jj_3R_78() {
    if (jj_scan_token(BAR)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_79()) {
    jj_scanpos = xsp;
    if (jj_3R_80()) return true;
    }
    return false;
  }

  private boolean jj_3R_65() {
    if (jj_3R_46()) return true;
    return false;
  }

  private boolean jj_3R_70() {
    if (jj_3R_44()) return true;
    return false;
  }

  private boolean jj_3R_76() {
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_72() {
    if (jj_3R_43()) return true;
    return false;
  }

  private boolean jj_3R_75() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_44()) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  private boolean jj_3R_71() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_74()) {
    jj_scanpos = xsp;
    if (jj_3R_75()) {
    jj_scanpos = xsp;
    if (jj_3R_76()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_74() {
    if (jj_3R_78()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_57() {
    if (jj_3R_46()) return true;
    return false;
  }

  private boolean jj_3_5() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3R_77() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_44()) return true;
    return false;
  }

  private boolean jj_3R_54() {
    if (jj_scan_token(LBRACKET)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_70()) jj_scanpos = xsp;
    if (jj_3R_71()) return true;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_3R_32()) return true;
    return false;
  }

  private boolean jj_3R_37() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3R_32() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_37()) {
    jj_scanpos = xsp;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) {
    jj_scanpos = xsp;
    if (jj_3R_41()) {
    jj_scanpos = xsp;
    if (jj_3R_42()) return true;
    }
    }
    }
    }
    }
    if (jj_3R_43()) return true;
    if (jj_3R_44()) return true;
    return false;
  }

  private boolean jj_3R_51() {
    if (jj_scan_token(NORMAND)) return true;
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3R_50() {
    if (jj_scan_token(NORMAND)) return true;
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_64() {
    if (jj_3R_32()) return true;
    return false;
  }

  private boolean jj_3R_48() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_64()) {
    jj_scanpos = xsp;
    if (jj_3R_65()) {
    jj_scanpos = xsp;
    if (jj_3R_66()) {
    jj_scanpos = xsp;
    if (jj_3R_67()) {
    jj_scanpos = xsp;
    if (jj_3R_68()) return true;
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_49() {
    if (jj_scan_token(NORMAND)) return true;
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_56() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3R_43() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(37)) {
    jj_scanpos = xsp;
    if (jj_scan_token(38)) {
    jj_scanpos = xsp;
    if (jj_scan_token(39)) {
    jj_scanpos = xsp;
    if (jj_scan_token(40)) {
    jj_scanpos = xsp;
    if (jj_scan_token(41)) {
    jj_scanpos = xsp;
    if (jj_scan_token(42)) {
    jj_scanpos = xsp;
    if (jj_scan_token(43)) {
    jj_scanpos = xsp;
    if (jj_scan_token(44)) {
    jj_scanpos = xsp;
    if (jj_scan_token(45)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(55)) {
    jj_scanpos = xsp;
    if (jj_scan_token(56)) {
    jj_scanpos = xsp;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_scan_token(59)) {
    jj_scanpos = xsp;
    if (jj_scan_token(60)) {
    jj_scanpos = xsp;
    if (jj_scan_token(61)) {
    jj_scanpos = xsp;
    if (jj_scan_token(62)) {
    jj_scanpos = xsp;
    if (jj_scan_token(63)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) {
    jj_scanpos = xsp;
    if (jj_scan_token(65)) {
    jj_scanpos = xsp;
    if (jj_scan_token(66)) {
    jj_scanpos = xsp;
    if (jj_scan_token(67)) {
    jj_scanpos = xsp;
    if (jj_scan_token(68)) {
    jj_scanpos = xsp;
    if (jj_scan_token(69)) {
    jj_scanpos = xsp;
    if (jj_scan_token(70)) {
    jj_scanpos = xsp;
    if (jj_scan_token(71)) {
    jj_scanpos = xsp;
    if (jj_scan_token(31)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_73() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_44()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_77()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_63() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(21)) {
    jj_scanpos = xsp;
    if (jj_3R_72()) return true;
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_73()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_46() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_62()) {
    jj_scanpos = xsp;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3R_63()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_62() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(50)) {
    jj_scanpos = xsp;
    if (jj_scan_token(35)) return true;
    }
    if (jj_3R_46()) return true;
    return false;
  }

  private boolean jj_3_1() {
    if (jj_3R_32()) return true;
    return false;
  }

  private boolean jj_3R_45() {
    if (jj_scan_token(SUBTRACT)) return true;
    return false;
  }

  private boolean jj_3R_36() {
    if (jj_3R_46()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_48()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_49()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(COMMA)) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(92)) {
    jj_scanpos = xsp;
    if (jj_scan_token(93)) return true;
    }
    if (jj_3R_48()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_50()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_48()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_51()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_33() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_45()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(19)) return true;
    }
    return false;
  }

  private boolean jj_3R_55() {
    if (jj_3R_32()) return true;
    return false;
  }

  private boolean jj_3R_44() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_55()) {
    jj_scanpos = xsp;
    if (jj_3R_56()) {
    jj_scanpos = xsp;
    if (jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) {
    jj_scanpos = xsp;
    if (jj_3R_59()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_7() {
    if (jj_scan_token(NOTSPACE)) return true;
    return false;
  }

  private boolean jj_3_6() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(37)) return true;
    }
    return false;
  }

  private boolean jj_3R_42() {
    if (jj_3R_54()) return true;
    return false;
  }

  /** Generated Token Manager. */
  public IntOOPLTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[79];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
      jj_la1_init_2();
      jj_la1_init_3();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0xa3a00000,0x0,0x88000,0x0,0x81a00000,0x80a00000,0x0,0x2000000,0x0,0x80a00000,0x80000000,0x83a00000,0xa3a00000,0xa3a88000,0x40000000,0x21000000,0x0,0x0,0x0,0x80a00000,0x0,0x0,0x1a00000,0x0,0x0,0x0,0x0,0x80000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000000,0x0,0x80000000,0x0,0x80a00000,0x80a00000,0x0,0x0,0x8000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80a00000,0x0,0x88a00000,0x0,0xa3a88000,0x0,0x80a00000,0x0,0xa3a88000,0x0,0x80a00000,0x80a00000,0x0,0x88a00000,0x88a00000,0x0,0xa3a88000,0xa3a88000,0x0,0xa3a88000,0x0,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0xfffffffc,0x20,0x0,0x40008,0xfffffff8,0xfffbfff0,0x1,0x0,0x40008,0xfffbfff0,0xfffbfff0,0xfffffffc,0xfffffffc,0xfffffffc,0x1,0x0,0x1,0x1,0x0,0xfffffff8,0x0,0x30,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x1,0x0,0x1,0x0,0x1,0x0,0x1,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0xfffffff8,0xfffffff8,0x1,0x1,0x0,0x1,0x1,0x0,0x0,0x0,0x0,0x1,0x1,0x1,0x1,0xfffffff8,0x0,0xfffffff8,0x0,0xfffffffc,0x0,0xfffffff8,0x0,0xfffffffc,0x0,0xfffffff8,0xfffffff8,0x0,0xfffffff8,0xfffffff8,0x0,0xfffffffc,0xfffffffc,0x0,0xfffffffc,0x0,};
   }
   private static void jj_la1_init_2() {
      jj_la1_2 = new int[] {0xff,0x0,0x0,0x0,0xff,0xff,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0x100,0x0,0x0,0x0,0x80,0xff,0x800,0x0,0x0,0x800,0xc000,0x0,0x20000,0x0,0x180000,0x0,0x20000,0x0,0x400000,0x0,0x800000,0x0,0x1000000,0x0,0x2000000,0x0,0x4000000,0x0,0x8000000,0x18c0ff,0x18c0ff,0x400,0x400,0x0,0x400,0x400,0x400,0x30000000,0x400,0x400,0x400,0x400,0x400,0x400,0xff,0x40000000,0xff,0x80000000,0xff,0x0,0xff,0x0,0xff,0x0,0xff,0xff,0x40000000,0xc0ff,0xc0ff,0x80000000,0x1800ff,0x1800ff,0x0,0xff,0x0,};
   }
   private static void jj_la1_init_3() {
      jj_la1_3 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x2,0x0,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x4,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[8];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public IntOOPL(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public IntOOPL(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new IntOOPLTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 79; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 79; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public IntOOPL(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new IntOOPLTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 79; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 79; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public IntOOPL(IntOOPLTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 79; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(IntOOPLTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 79; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[100];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 79; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 100; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 8; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
